<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: linearly_independent_subset_finder.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_5e84fc1d53d6c0d63218f3bf54f21eee.html">svm</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">linearly_independent_subset_finder.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2008  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef DLIB_LISfh_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define DLIB_LISfh_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;linearly_independent_subset_finder_abstract.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;../matrix.h&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;function.h&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;../std_allocator.h&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;../algs.h&quot;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &quot;../serialize.h&quot;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;../is_kind.h&quot;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;../string.h&quot;</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &quot;../rand.h&quot;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;{</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160; </div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> kernel_type&gt;</div><div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="classdlib_1_1linearly__independent__subset__finder.html">   24</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classdlib_1_1linearly__independent__subset__finder.html">linearly_independent_subset_finder</a></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    {</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00056"></a><span class="lineno"><a class="line" href="classdlib_1_1linearly__independent__subset__finder.html#a9a2a2594c9a4349d86615ae65b5e6438">   56</a></span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::scalar_type <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html#a9a2a2594c9a4349d86615ae65b5e6438">scalar_type</a>;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::sample_type sample_type;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::sample_type type;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::mem_manager_type mem_manager_type;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160; </div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html">linearly_independent_subset_finder</a> (</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        ) : </div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;            my_max_dictionary_size(100),</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;            min_tolerance(0.001)</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        {</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;            clear_dictionary();</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        }</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160; </div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html">linearly_independent_subset_finder</a> (</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;            <span class="keyword">const</span> kernel_type&amp; kernel_, </div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> max_dictionary_size_,</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;            <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html#a9a2a2594c9a4349d86615ae65b5e6438">scalar_type</a> min_tolerance_ = 0.001</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        ) : </div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;            kernel(kernel_), </div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;            my_max_dictionary_size(max_dictionary_size_),</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;            min_tolerance(min_tolerance_)</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        {</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;            <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;            DLIB_ASSERT(min_tolerance_ &gt; 0 &amp;&amp; max_dictionary_size_ &gt; 1,</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;                <span class="stringliteral">&quot;\tlinearly_independent_subset_finder()&quot;</span></div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tinvalid argument to constructor&quot;</span></div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tmin_tolerance_: &quot;</span> &lt;&lt; min_tolerance_</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tmax_dictionary_size_: &quot;</span> &lt;&lt; max_dictionary_size_</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tthis:           &quot;</span> &lt;&lt; <span class="keyword">this</span></div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;                );</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;            clear_dictionary();</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        }</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160; </div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> max_dictionary_size()<span class="keyword"> const</span></div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;            <span class="keywordflow">return</span> my_max_dictionary_size;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        }</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160; </div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        <span class="keyword">const</span> kernel_type&amp; get_kernel (</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;            <span class="keywordflow">return</span> kernel;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        }</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160; </div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html#a9a2a2594c9a4349d86615ae65b5e6438">scalar_type</a> minimum_tolerance(</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;            <span class="keywordflow">return</span> min_tolerance;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        }</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160; </div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        <span class="keywordtype">void</span> set_minimum_tolerance (</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;            <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html#a9a2a2594c9a4349d86615ae65b5e6438">scalar_type</a> min_tol</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        )</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        {</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;            <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;            DLIB_ASSERT(min_tol &gt; 0,</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;                <span class="stringliteral">&quot;\tlinearly_independent_subset_finder::set_minimum_tolerance()&quot;</span></div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tinvalid argument to this function&quot;</span></div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tmin_tol: &quot;</span> &lt;&lt; min_tol</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\tthis:    &quot;</span> &lt;&lt; <span class="keyword">this</span></div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;                );</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;            min_tolerance = min_tol;</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;        }</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160; </div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;        <span class="keywordtype">void</span> clear_dictionary ()</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        {</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;            dictionary.clear();</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;            min_strength = 0;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;            min_vect_idx = 0;</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160; </div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;            K_inv.set_size(0,0);</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;            K.set_size(0,0);</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        }</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160; </div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html#a9a2a2594c9a4349d86615ae65b5e6438">scalar_type</a> projection_error (</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;            <span class="keyword">const</span> sample_type&amp; x</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;            <span class="keyword">const</span> <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html#a9a2a2594c9a4349d86615ae65b5e6438">scalar_type</a> kx = kernel(x,x);</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;            <span class="keywordflow">if</span> (dictionary.size() == 0)</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;            {</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;                <span class="keywordflow">return</span> kx;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;            }</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;            <span class="keywordflow">else</span></div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;            {</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;                <span class="comment">// fill in k</span></div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;                k.set_size(dictionary.size());</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;                <span class="keywordflow">for</span> (<span class="keywordtype">long</span> r = 0; r &lt; k.nr(); ++r)</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;                    k(r) = kernel(x,dictionary[r]);</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160; </div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;                <span class="comment">// compute the error we would have if we approximated the new x sample</span></div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;                <span class="comment">// with the dictionary.  That is, do the ALD test from the KRLS paper.</span></div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;                a = K_inv*k;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;                <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html#a9a2a2594c9a4349d86615ae65b5e6438">scalar_type</a> delta = kx - trans(k)*a;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160; </div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;                <span class="keywordflow">return</span> delta;</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;            }</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        }</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160; </div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        <span class="keywordtype">bool</span> add (</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;            <span class="keyword">const</span> sample_type&amp; x</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        )</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        {</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;            <span class="keyword">const</span> <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html#a9a2a2594c9a4349d86615ae65b5e6438">scalar_type</a> kx = kernel(x,x);</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;            <span class="keywordflow">if</span> (dictionary.size() == 0)</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;            {</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;                <span class="comment">// just ignore this sample if it is the zero vector (or really close to being zero)</span></div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;                <span class="keywordflow">if</span> (std::abs(kx) &gt; std::numeric_limits&lt;scalar_type&gt;::epsilon())</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;                {</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;                    <span class="comment">// set initial state since this is the first sample we have seen</span></div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;                    K_inv.set_size(1,1);</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;                    K_inv(0,0) = 1/kx;</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160; </div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;                    K.set_size(1,1);</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;                    K(0,0) = kx;</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160; </div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;                    dictionary.push_back(x);</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;                    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;                }</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;                <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;            }</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;            <span class="keywordflow">else</span></div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;            {</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;                <span class="comment">// fill in k</span></div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;                k.set_size(dictionary.size());</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;                <span class="keywordflow">for</span> (<span class="keywordtype">long</span> r = 0; r &lt; k.nr(); ++r)</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;                    k(r) = kernel(x,dictionary[r]);</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160; </div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;                <span class="comment">// compute the error we would have if we approximated the new x sample</span></div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;                <span class="comment">// with the dictionary.  That is, do the ALD test from the KRLS paper.</span></div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;                a = K_inv*k;</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;                <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html#a9a2a2594c9a4349d86615ae65b5e6438">scalar_type</a> delta = kx - trans(k)*a;</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160; </div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;                <span class="comment">// if this new vector is approximately linearly independent of the vectors</span></div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;                <span class="comment">// in our dictionary.  </span></div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;                <span class="keywordflow">if</span> (delta &gt; min_strength &amp;&amp; delta &gt; min_tolerance)</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;                {</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;                    <span class="keywordflow">if</span> (dictionary.size() == my_max_dictionary_size)</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;                    {</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;                        <span class="comment">// if we have never computed the min_strength then we should compute it </span></div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;                        <span class="keywordflow">if</span> (min_strength == 0)</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;                            <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html#a1f755474f99781f9f78d02e958ceea6b">recompute_min_strength</a>();</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160; </div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;                        <span class="keyword">const</span> <span class="keywordtype">long</span> i = min_vect_idx;</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160; </div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;                        <span class="comment">// replace the min strength vector with x.  Put the new vector onto the end of</span></div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;                        <span class="comment">// dictionary and remove the vector at position i.</span></div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;                        dictionary.erase(dictionary.begin()+i);</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;                        dictionary.push_back(x);</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160; </div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;                        <span class="comment">// compute reduced K_inv.</span></div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;                        <span class="comment">// Remove the i&#39;th vector from the inverse kernel matrix.  This formula is basically</span></div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;                        <span class="comment">// just the reverse of the way K_inv is updated by equation 3.14 below.</span></div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;                        temp = removerc(K_inv,i,i) - remove_row(colm(K_inv,i)/K_inv(i,i),i)*remove_col(rowm(K_inv,i),i);</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160; </div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;                        <span class="comment">// recompute these guys since they were computed with the old</span></div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;                        <span class="comment">// kernel matrix</span></div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;                        k2 = remove_row(k,i);</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;                        a2 = temp*k2;</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;                        delta = kx - trans(k2)*a2;</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160; </div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;                        <span class="comment">// now update temp with the new dictionary vector</span></div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;                        <span class="comment">// update the middle part of the matrix</span></div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;                        set_subm(K_inv, get_rect(temp)) = temp + a2*trans(a2)/delta;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;                        <span class="comment">// update the right column of the matrix</span></div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;                        set_subm(K_inv, 0, temp.nr(),temp.nr(),1) = -a2/delta;</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;                        <span class="comment">// update the bottom row of the matrix</span></div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;                        set_subm(K_inv, temp.nr(), 0, 1, temp.nr()) = trans(-a2/delta);</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;                        <span class="comment">// update the bottom right corner of the matrix</span></div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;                        K_inv(temp.nr(), temp.nc()) = 1/delta;</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160; </div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;                        <span class="comment">// now update the kernel matrix K</span></div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;                        set_subm(K,get_rect(temp)) = removerc(K, i,i);</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;                        set_subm(K, 0, K.nr()-1,K.nr()-1,1) = k2;</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;                        <span class="comment">// update the bottom row of the matrix</span></div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;                        set_subm(K, K.nr()-1, 0, 1, K.nr()-1) = trans(k2);</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;                        K(K.nr()-1, K.nc()-1) = kx;</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160; </div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;                        <span class="comment">// now we have to recompute the min_strength in this case</span></div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;                        <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html#a1f755474f99781f9f78d02e958ceea6b">recompute_min_strength</a>();</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;                    }</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;                    <span class="keywordflow">else</span></div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;                    {</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;                        <span class="comment">// update K_inv by computing the new one in the temp matrix (equation 3.14 from Engel)</span></div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;                        temp.set_size(K_inv.nr()+1, K_inv.nc()+1);</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;                        <span class="comment">// update the middle part of the matrix</span></div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;                        set_subm(temp, get_rect(K_inv)) = K_inv + a*trans(a)/delta;</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;                        <span class="comment">// update the right column of the matrix</span></div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;                        set_subm(temp, 0, K_inv.nr(),K_inv.nr(),1) = -a/delta;</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;                        <span class="comment">// update the bottom row of the matrix</span></div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;                        set_subm(temp, K_inv.nr(), 0, 1, K_inv.nr()) = trans(-a/delta);</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;                        <span class="comment">// update the bottom right corner of the matrix</span></div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;                        temp(K_inv.nr(), K_inv.nc()) = 1/delta;</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;                        <span class="comment">// put temp into K_inv</span></div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;                        temp.swap(K_inv);</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160; </div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160; </div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;                        <span class="comment">// update K (the kernel matrix)</span></div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;                        temp.set_size(K.nr()+1, K.nc()+1);</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;                        set_subm(temp, get_rect(K)) = K;</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;                        <span class="comment">// update the right column of the matrix</span></div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;                        set_subm(temp, 0, K.nr(),K.nr(),1) = k;</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;                        <span class="comment">// update the bottom row of the matrix</span></div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;                        set_subm(temp, K.nr(), 0, 1, K.nr()) = trans(k);</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;                        temp(K.nr(), K.nc()) = kx;</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;                        <span class="comment">// put temp into K</span></div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;                        temp.swap(K);</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160; </div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160; </div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;                        <span class="comment">// add x to the dictionary</span></div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;                        dictionary.push_back(x);</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160; </div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;                    }</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;                    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;                }</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;                <span class="keywordflow">else</span></div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;                {</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;                    <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;                }</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;            }</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;        }</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160; </div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;        <span class="keywordtype">void</span> swap (</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;            linearly_independent_subset_finder&amp; item</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;        )</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;        {</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;            <a class="code" href="namespacedlib.html#ad37c77243cb5521ab47cefddf651cda5">exchange</a>(kernel, item.kernel);</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;            dictionary.swap(item.dictionary);</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;            <a class="code" href="namespacedlib.html#ad37c77243cb5521ab47cefddf651cda5">exchange</a>(min_strength, item.min_strength);</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;            <a class="code" href="namespacedlib.html#ad37c77243cb5521ab47cefddf651cda5">exchange</a>(min_vect_idx, item.min_vect_idx);</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;            K_inv.swap(item.K_inv);</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;            K.swap(item.K);</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;            <a class="code" href="namespacedlib.html#ad37c77243cb5521ab47cefddf651cda5">exchange</a>(my_max_dictionary_size, item.my_max_dictionary_size);</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;            <a class="code" href="namespacedlib.html#ad37c77243cb5521ab47cefddf651cda5">exchange</a>(min_tolerance, item.min_tolerance);</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160; </div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;            <span class="comment">// non-state temp members</span></div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;            a.swap(item.a);</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;            k.swap(item.k);</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;            a2.swap(item.a2);</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;            k2.swap(item.k2);</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;            temp.swap(item.temp);</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;        }</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160; </div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> size (</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;        )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> dictionary.size(); }</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160; </div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;        <span class="keyword">const</span> matrix&lt;sample_type,0,1,mem_manager_type&gt; get_dictionary (</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;<span class="keyword">        </span>{ </div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;            <span class="keywordflow">return</span> mat(dictionary);</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;        }</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160; </div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;        <span class="keyword">friend</span> <span class="keywordtype">void</span> serialize(<span class="keyword">const</span> linearly_independent_subset_finder&amp; item, std::ostream&amp; out)</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;        {</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;            serialize(item.kernel, out);</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;            serialize(item.dictionary, out);</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;            serialize(item.min_strength, out);</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;            serialize(item.min_vect_idx, out);</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;            serialize(item.K_inv, out);</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;            serialize(item.K, out);</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;            serialize(item.my_max_dictionary_size, out);</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;            serialize(item.min_tolerance, out);</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;        }</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160; </div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;        <span class="keyword">friend</span> <span class="keywordtype">void</span> deserialize(linearly_independent_subset_finder&amp; item, std::istream&amp; in)</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;        {</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;            deserialize(item.kernel, in);</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;            deserialize(item.dictionary, in);</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;            deserialize(item.min_strength, in);</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;            deserialize(item.min_vect_idx, in);</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;            deserialize(item.K_inv, in);</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;            deserialize(item.K, in);</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;            deserialize(item.my_max_dictionary_size, in);</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;            deserialize(item.min_tolerance, in);</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;        }</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160; </div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;        <span class="keyword">const</span> sample_type&amp; operator[] (</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> index</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;            <span class="keywordflow">return</span> dictionary[index];</div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;        }</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160; </div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;        <span class="keyword">const</span> matrix&lt;scalar_type,0,0,mem_manager_type&gt;&amp; get_kernel_matrix (</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;            <span class="keywordflow">return</span> K;</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;        }</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160; </div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;        <span class="keyword">const</span> matrix&lt;scalar_type,0,0,mem_manager_type&gt;&amp; get_inv_kernel_marix (</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;        )<span class="keyword"> const</span></div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;            <span class="keywordflow">return</span> K_inv;</div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;        }</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160; </div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160; </div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;        <span class="keyword">typedef</span> std_allocator&lt;sample_type, mem_manager_type&gt; alloc_sample_type;</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;        <span class="keyword">typedef</span> std_allocator&lt;scalar_type, mem_manager_type&gt; alloc_scalar_type;</div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;        <span class="keyword">typedef</span> std::vector&lt;sample_type,alloc_sample_type&gt; dictionary_vector_type;</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;        <span class="keyword">typedef</span> std::vector&lt;scalar_type,alloc_scalar_type&gt; scalar_vector_type;</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160; </div><div class="line"><a name="l00358"></a><span class="lineno"><a class="line" href="classdlib_1_1linearly__independent__subset__finder.html#a1f755474f99781f9f78d02e958ceea6b">  358</a></span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html#a1f755474f99781f9f78d02e958ceea6b">recompute_min_strength</a> (</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;        )</div><div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;        {</div><div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;            min_strength = std::numeric_limits&lt;scalar_type&gt;::max();</div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160; </div><div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;            <span class="comment">// here we loop over each dictionary vector and compute what its delta would be if</span></div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;            <span class="comment">// we were to remove it from the dictionary and then try to add it back in.</span></div><div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> i = 0; i &lt; dictionary.size(); ++i)</div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;            {</div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;                <span class="comment">// compute a2 = K_inv*k but where dictionary vector i has been removed</span></div><div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;                a2 = (removerc(K_inv,i,i) - remove_row(colm(K_inv,i)/K_inv(i,i),i)*remove_col(rowm(K_inv,i),i)) *</div><div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;                    (remove_row(colm(K,i),i));</div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;                <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html#a9a2a2594c9a4349d86615ae65b5e6438">scalar_type</a> delta = K(i,i) - trans(remove_row(colm(K,i),i))*a2;</div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160; </div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;                <span class="keywordflow">if</span> (delta &lt; min_strength)</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;                {</div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;                    min_strength = delta;</div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;                    min_vect_idx = i;</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;                }</div><div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;            }</div><div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;        }</div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160; </div><div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160; </div><div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;        kernel_type kernel;</div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;        dictionary_vector_type dictionary;</div><div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;        <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html#a9a2a2594c9a4349d86615ae65b5e6438">scalar_type</a> min_strength;</div><div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> min_vect_idx;</div><div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160; </div><div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;        <a class="code" href="classdlib_1_1matrix.html">matrix&lt;scalar_type,0,0,mem_manager_type&gt;</a> K_inv;</div><div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;        <a class="code" href="classdlib_1_1matrix.html">matrix&lt;scalar_type,0,0,mem_manager_type&gt;</a> K;</div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160; </div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> my_max_dictionary_size;</div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;        <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html#a9a2a2594c9a4349d86615ae65b5e6438">scalar_type</a> min_tolerance;</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160; </div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;        <span class="comment">// temp variables here just so we don&#39;t have to reconstruct them over and over.  Thus, </span></div><div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;        <span class="comment">// they aren&#39;t really part of the state of this object.</span></div><div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;        <span class="keyword">mutable</span> <a class="code" href="classdlib_1_1matrix.html">matrix&lt;scalar_type,0,1,mem_manager_type&gt;</a> a, a2;</div><div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;        <span class="keyword">mutable</span> <a class="code" href="classdlib_1_1matrix.html">matrix&lt;scalar_type,0,1,mem_manager_type&gt;</a> k, k2;</div><div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;        <span class="keyword">mutable</span> <a class="code" href="classdlib_1_1matrix.html">matrix&lt;scalar_type,0,0,mem_manager_type&gt;</a> temp;</div><div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160; </div><div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;    };</div><div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160; </div><div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160; </div><div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> kernel_type&gt;</div><div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;    <span class="keywordtype">void</span> swap(linearly_independent_subset_finder&lt;kernel_type&gt;&amp; a, linearly_independent_subset_finder&lt;kernel_type&gt;&amp; b)</div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;    { a.swap(b); }</div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160; </div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160; </div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;        &gt;</div><div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;    <span class="keyword">const</span> matrix_op&lt;op_array_to_mat&lt;linearly_independent_subset_finder&lt;T&gt; &gt; &gt; mat (</div><div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;        <span class="keyword">const</span> linearly_independent_subset_finder&lt;T&gt;&amp; m </div><div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;    )</div><div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;    {</div><div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;        <span class="keyword">typedef</span> op_array_to_mat&lt;linearly_independent_subset_finder&lt;T&gt; &gt; op;</div><div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;        <span class="keywordflow">return</span> matrix_op&lt;op&gt;(op(m));</div><div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;    }</div><div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160; </div><div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160;    <span class="keyword">namespace </span>impl</div><div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;    {</div><div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;        <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;            <span class="keyword">typename</span> kernel_type,</div><div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160;            <span class="keyword">typename</span> vector_type,</div><div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160;            <span class="keyword">typename</span> rand_type</div><div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;            &gt;</div><div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;        <span class="keywordtype">void</span> fill_lisf (</div><div class="line"><a name="l00433"></a><span class="lineno">  433</span>&#160;            linearly_independent_subset_finder&lt;kernel_type&gt;&amp; lisf,</div><div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;            <span class="keyword">const</span> vector_type&amp; samples,</div><div class="line"><a name="l00435"></a><span class="lineno">  435</span>&#160;            rand_type&amp; rnd,</div><div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;            <span class="keywordtype">int</span> sampling_size </div><div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;        )</div><div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160;        {   </div><div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;            <span class="comment">// make sure requires clause is not broken</span></div><div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;            DLIB_ASSERT(is_vector(samples) &amp;&amp; sampling_size &gt; 0,</div><div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;                <span class="stringliteral">&quot;\t void fill_lisf()&quot;</span></div><div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t invalid arguments to this function&quot;</span></div><div class="line"><a name="l00443"></a><span class="lineno">  443</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t is_vector(samples): &quot;</span> &lt;&lt; is_vector(samples) </div><div class="line"><a name="l00444"></a><span class="lineno">  444</span>&#160;                &lt;&lt; <span class="stringliteral">&quot;\n\t sampling_size: &quot;</span> &lt;&lt; sampling_size</div><div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;                );</div><div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160; </div><div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;            <span class="comment">// no need to do anything if there aren&#39;t any samples</span></div><div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;            <span class="keywordflow">if</span> (samples.size() == 0)</div><div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;                <span class="keywordflow">return</span>;</div><div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160; </div><div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;            <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::scalar_type scalar_type;</div><div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160; </div><div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;            <span class="comment">// Start out by guessing what a reasonable projection error tolerance is. We will use</span></div><div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;            <span class="comment">// the biggest projection error we see in a small sample.</span></div><div class="line"><a name="l00455"></a><span class="lineno">  455</span>&#160;            scalar_type tol = 0;</div><div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;            <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; sampling_size; ++i)</div><div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;            {</div><div class="line"><a name="l00458"></a><span class="lineno">  458</span>&#160;                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> idx = rnd.get_random_32bit_number()%samples.size();</div><div class="line"><a name="l00459"></a><span class="lineno">  459</span>&#160;                <span class="keyword">const</span> scalar_type temp = lisf.projection_error(samples(idx)); </div><div class="line"><a name="l00460"></a><span class="lineno">  460</span>&#160;                <span class="keywordflow">if</span> (temp &gt; tol)</div><div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;                    tol = temp;</div><div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;            }</div><div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160; </div><div class="line"><a name="l00464"></a><span class="lineno">  464</span>&#160;            <span class="keyword">const</span> scalar_type min_tol = lisf.minimum_tolerance();</div><div class="line"><a name="l00465"></a><span class="lineno">  465</span>&#160; </div><div class="line"><a name="l00466"></a><span class="lineno">  466</span>&#160;            <span class="comment">// run many rounds of random sampling.  In each round we drop the tolerance lower.</span></div><div class="line"><a name="l00467"></a><span class="lineno">  467</span>&#160;            <span class="keywordflow">while</span> (tol &gt;= min_tol &amp;&amp; lisf.size() &lt; lisf.max_dictionary_size())</div><div class="line"><a name="l00468"></a><span class="lineno">  468</span>&#160;            {</div><div class="line"><a name="l00469"></a><span class="lineno">  469</span>&#160;                tol *= 0.5;</div><div class="line"><a name="l00470"></a><span class="lineno">  470</span>&#160;                lisf.set_minimum_tolerance(std::max(tol, min_tol));</div><div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;                <span class="keywordtype">int</span> add_failures = 0;</div><div class="line"><a name="l00472"></a><span class="lineno">  472</span>&#160; </div><div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;                <span class="comment">// Keep picking random samples and adding them into the lisf.  Stop when we either</span></div><div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;                <span class="comment">// fill it up or can&#39;t find any more samples with projection error larger than the</span></div><div class="line"><a name="l00475"></a><span class="lineno">  475</span>&#160;                <span class="comment">// current tolerance.</span></div><div class="line"><a name="l00476"></a><span class="lineno">  476</span>&#160;                <span class="keywordflow">while</span> (lisf.size() &lt; lisf.max_dictionary_size() &amp;&amp; add_failures &lt; sampling_size) </div><div class="line"><a name="l00477"></a><span class="lineno">  477</span>&#160;                {</div><div class="line"><a name="l00478"></a><span class="lineno">  478</span>&#160;                    <span class="keywordflow">if</span> (lisf.add(samples(rnd.get_random_32bit_number()%samples.size())) == <span class="keyword">false</span>)</div><div class="line"><a name="l00479"></a><span class="lineno">  479</span>&#160;                    {</div><div class="line"><a name="l00480"></a><span class="lineno">  480</span>&#160;                        ++add_failures;</div><div class="line"><a name="l00481"></a><span class="lineno">  481</span>&#160;                    }</div><div class="line"><a name="l00482"></a><span class="lineno">  482</span>&#160;                }</div><div class="line"><a name="l00483"></a><span class="lineno">  483</span>&#160;            }</div><div class="line"><a name="l00484"></a><span class="lineno">  484</span>&#160; </div><div class="line"><a name="l00485"></a><span class="lineno">  485</span>&#160;            <span class="comment">// set this back to its original value</span></div><div class="line"><a name="l00486"></a><span class="lineno">  486</span>&#160;            lisf.set_minimum_tolerance(min_tol);</div><div class="line"><a name="l00487"></a><span class="lineno">  487</span>&#160;        }</div><div class="line"><a name="l00488"></a><span class="lineno">  488</span>&#160;    }</div><div class="line"><a name="l00489"></a><span class="lineno">  489</span>&#160; </div><div class="line"><a name="l00490"></a><span class="lineno">  490</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00491"></a><span class="lineno">  491</span>&#160;        <span class="keyword">typename</span> kernel_type,</div><div class="line"><a name="l00492"></a><span class="lineno">  492</span>&#160;        <span class="keyword">typename</span> vector_type</div><div class="line"><a name="l00493"></a><span class="lineno">  493</span>&#160;        &gt;</div><div class="line"><a name="l00494"></a><span class="lineno">  494</span>&#160;    <span class="keywordtype">void</span> fill_lisf (</div><div class="line"><a name="l00495"></a><span class="lineno">  495</span>&#160;        linearly_independent_subset_finder&lt;kernel_type&gt;&amp; lisf,</div><div class="line"><a name="l00496"></a><span class="lineno">  496</span>&#160;        <span class="keyword">const</span> vector_type&amp; samples</div><div class="line"><a name="l00497"></a><span class="lineno">  497</span>&#160;    )</div><div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160;    {   </div><div class="line"><a name="l00499"></a><span class="lineno">  499</span>&#160;        <a class="code" href="classdlib_1_1rand.html">dlib::rand</a> rnd;</div><div class="line"><a name="l00500"></a><span class="lineno">  500</span>&#160;        impl::fill_lisf(lisf, mat(samples),rnd, 2000);</div><div class="line"><a name="l00501"></a><span class="lineno">  501</span>&#160;    }</div><div class="line"><a name="l00502"></a><span class="lineno">  502</span>&#160; </div><div class="line"><a name="l00503"></a><span class="lineno">  503</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00504"></a><span class="lineno">  504</span>&#160;        <span class="keyword">typename</span> kernel_type,</div><div class="line"><a name="l00505"></a><span class="lineno">  505</span>&#160;        <span class="keyword">typename</span> vector_type,</div><div class="line"><a name="l00506"></a><span class="lineno">  506</span>&#160;        <span class="keyword">typename</span> rand_type</div><div class="line"><a name="l00507"></a><span class="lineno">  507</span>&#160;        &gt;</div><div class="line"><a name="l00508"></a><span class="lineno">  508</span>&#160;    <span class="keyword">typename</span> enable_if&lt;is_rand&lt;rand_type&gt; &gt;::type fill_lisf (</div><div class="line"><a name="l00509"></a><span class="lineno">  509</span>&#160;        linearly_independent_subset_finder&lt;kernel_type&gt;&amp; lisf,</div><div class="line"><a name="l00510"></a><span class="lineno">  510</span>&#160;        <span class="keyword">const</span> vector_type&amp; samples,</div><div class="line"><a name="l00511"></a><span class="lineno">  511</span>&#160;        rand_type&amp; rnd,</div><div class="line"><a name="l00512"></a><span class="lineno">  512</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">int</span> sampling_size = 2000</div><div class="line"><a name="l00513"></a><span class="lineno">  513</span>&#160;    )</div><div class="line"><a name="l00514"></a><span class="lineno">  514</span>&#160;    {   </div><div class="line"><a name="l00515"></a><span class="lineno">  515</span>&#160;        impl::fill_lisf(lisf, mat(samples),rnd, sampling_size);</div><div class="line"><a name="l00516"></a><span class="lineno">  516</span>&#160;    }</div><div class="line"><a name="l00517"></a><span class="lineno">  517</span>&#160; </div><div class="line"><a name="l00518"></a><span class="lineno">  518</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00519"></a><span class="lineno">  519</span>&#160;        <span class="keyword">typename</span> kernel_type,</div><div class="line"><a name="l00520"></a><span class="lineno">  520</span>&#160;        <span class="keyword">typename</span> vector_type,</div><div class="line"><a name="l00521"></a><span class="lineno">  521</span>&#160;        <span class="keyword">typename</span> rand_type</div><div class="line"><a name="l00522"></a><span class="lineno">  522</span>&#160;        &gt;</div><div class="line"><a name="l00523"></a><span class="lineno">  523</span>&#160;    <span class="keyword">typename</span> disable_if&lt;is_rand&lt;rand_type&gt; &gt;::type fill_lisf (</div><div class="line"><a name="l00524"></a><span class="lineno">  524</span>&#160;        linearly_independent_subset_finder&lt;kernel_type&gt;&amp; lisf,</div><div class="line"><a name="l00525"></a><span class="lineno">  525</span>&#160;        <span class="keyword">const</span> vector_type&amp; samples,</div><div class="line"><a name="l00526"></a><span class="lineno">  526</span>&#160;        rand_type random_seed,</div><div class="line"><a name="l00527"></a><span class="lineno">  527</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">int</span> sampling_size = 2000</div><div class="line"><a name="l00528"></a><span class="lineno">  528</span>&#160;    )</div><div class="line"><a name="l00529"></a><span class="lineno">  529</span>&#160;    {   </div><div class="line"><a name="l00530"></a><span class="lineno">  530</span>&#160;        <a class="code" href="classdlib_1_1rand.html">dlib::rand</a> rnd;</div><div class="line"><a name="l00531"></a><span class="lineno">  531</span>&#160;        rnd.set_seed(cast_to_string(random_seed));</div><div class="line"><a name="l00532"></a><span class="lineno">  532</span>&#160;        impl::fill_lisf(lisf, mat(samples), rnd, sampling_size);</div><div class="line"><a name="l00533"></a><span class="lineno">  533</span>&#160;    }</div><div class="line"><a name="l00534"></a><span class="lineno">  534</span>&#160; </div><div class="line"><a name="l00535"></a><span class="lineno">  535</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00536"></a><span class="lineno">  536</span>&#160; </div><div class="line"><a name="l00537"></a><span class="lineno">  537</span>&#160;}</div><div class="line"><a name="l00538"></a><span class="lineno">  538</span>&#160; </div><div class="line"><a name="l00539"></a><span class="lineno">  539</span>&#160;<span class="preprocessor">#endif // DLIB_LISfh_</span></div><div class="line"><a name="l00540"></a><span class="lineno">  540</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassdlib_1_1linearly__independent__subset__finder_html_a1f755474f99781f9f78d02e958ceea6b"><div class="ttname"><a href="classdlib_1_1linearly__independent__subset__finder.html#a1f755474f99781f9f78d02e958ceea6b">dlib::linearly_independent_subset_finder::recompute_min_strength</a></div><div class="ttdeci">void recompute_min_strength()</div><div class="ttdef"><b>Definition:</b> linearly_independent_subset_finder.h:358</div></div>
<div class="ttc" id="aclassdlib_1_1rand_html"><div class="ttname"><a href="classdlib_1_1rand.html">dlib::rand</a></div><div class="ttdef"><b>Definition:</b> rand_kernel_1.h:18</div></div>
<div class="ttc" id="anamespacedlib_html_ad37c77243cb5521ab47cefddf651cda5"><div class="ttname"><a href="namespacedlib.html#ad37c77243cb5521ab47cefddf651cda5">dlib::exchange</a></div><div class="ttdeci">void exchange(T &amp;a, T &amp;b)</div><div class="ttdef"><b>Definition:</b> algs.h:326</div></div>
<div class="ttc" id="aclassdlib_1_1linearly__independent__subset__finder_html"><div class="ttname"><a href="classdlib_1_1linearly__independent__subset__finder.html">dlib::linearly_independent_subset_finder</a></div><div class="ttdef"><b>Definition:</b> linearly_independent_subset_finder.h:24</div></div>
<div class="ttc" id="aclassdlib_1_1matrix_html"><div class="ttname"><a href="classdlib_1_1matrix.html">dlib::matrix&lt; scalar_type, 0, 0, mem_manager_type &gt;</a></div></div>
<div class="ttc" id="aclassdlib_1_1linearly__independent__subset__finder_html_a9a2a2594c9a4349d86615ae65b5e6438"><div class="ttname"><a href="classdlib_1_1linearly__independent__subset__finder.html#a9a2a2594c9a4349d86615ae65b5e6438">dlib::linearly_independent_subset_finder::scalar_type</a></div><div class="ttdeci">kernel_type::scalar_type scalar_type</div><div class="ttdef"><b>Definition:</b> linearly_independent_subset_finder.h:56</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
